/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024-2026 Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

class registerPrompt{
    constructor(){
        //Grab user prompt
        this.user = document.querySelector("#reset-pass-username-prompt");
        //Detect if we're initiating or completing a password request
        this.initiating = this.user != null
        
        //If we're working with an existing request
        if(!this.initiating){
            //Grab pass prompts
            this.pass = document.querySelector("#reset-pass-prompt");
            this.passConfirm = document.querySelector("#reset-pass-confirm-prompt");
            //Strip reset token from query string
            this.token = window.location.search.replace('?token=','');
        }

        //Grab register button
        this.button = document.querySelector("#reset-pass-button");
        //Grab altcha widget
        this.altcha = document.querySelector("altcha-widget");
        //Setup null property to hold verification payload from altcha widget
        this.verification = null

        //Run input setup after DOM content has completely loaded to ensure altcha event listeners work
        document.addEventListener('DOMContentLoaded', this.setupInput.bind(this));
    }

    setupInput(){
        //Add verification event listener to altcha widget
        this.altcha.addEventListener("verified", this.verify.bind(this));

        //Add register event listener to register button
        this.button.addEventListener("click", this.register.bind(this));
    }

    verify(event){
        //pull verification payload from event
        this.verification = event.detail.payload;
    }

    async register(){
        //If altcha verification isn't complete
        if(this.verification == null){
            //don't bother
            return;
        }

        //If we're initiating a password change request
        if(this.initiating){
            await utils.ajax.requestPasswordReset(this.user.value, this.verification);
        //If we're completing a password change
        }else{
            //if the confirmation password doesn't match
            if(this.pass.value != this.passConfirm.value){
                //Scream and shout
                new canopyUXUtils.popup(`<p>Confirmation password does not match!</p>`);
                return;
            }

            //Send the registration informaiton off to the server
            await utils.ajax.resetPassword(this.token , this.pass.value , this.passConfirm.value , this.verification);
        }
    }
}

const registerForm = new registerPrompt();